---
title: Parsing and serializing XML
slug: Web/Guide/Parsing_and_serializing_XML
tags:
  - AJAX
  - Add-ons
  - DOM
  - DOM Parsing
  - Document
  - Extensions
  - Guide
  - HTMLDocument
  - JSON
  - Parsing
  - Parsing XML
  - Serializing
  - Serializing XML
  - XML
  - XMLDocument
  - XMLHttpRequest
---
<p>At times, you may need to parse {{Glossary("XML")}} content and convert it into a {{Glossary("DOM")}} tree, or, conversely, serialize an existing DOM tree into XML. <span class="seoSummary">In this article, we'll look at the objects provided by the web platform to make the common tasks of serializing and parsing XML easy.</span></p>

<dl>
	<dt>{{domxref("XMLSerializer")}}</dt>
	<dd>Serializes DOM trees, converting them into strings containing XML.</dd>
	<dt>{{domxref("DOMParser")}}</dt>
	<dd>Constructs a DOM tree by parsing a string containing XML, returning a {{domxref("XMLDocument")}} or {{domxref("Document")}} as appropriate based on the input data.</dd>
	<dt>{{domxref("XMLHttpRequest")}}</dt>
	<dd>Loads content from a URL; XML content is returned as an XML {{domxref("Document")}} object with a DOM tree built from the XML itself.</dd>
	<dt><a href="/en-US/docs/Web/XPath">XPath</a></dt>
	<dd>A technology for creating strings that contain addresses for specific portions of an XML document, and locating XML nodes based on those addresses.</dd>
</dl>

<h2 id="Creating_an_XML_document">Creating an XML document</h2>

<p>Using one of the following approaches to create an XML document (which is an instance of {{domxref("Document")}}.</p>

<h3 id="Parsing_strings_into_DOM_trees">Parsing strings into DOM trees</h3>

<p>This example converts an XML fragment in a string into a DOM tree using a {{domxref("DOMParser")}}:</p>

<div style="overflow: hidden;">
<pre class="brush: js notranslate">const xmlStr = '&lt;a id="a"&gt;&lt;b id="b"&gt;hey!&lt;/b&gt;&lt;/a&gt;';
const parser = new DOMParser();
const dom = parser.parseFromString(xmlStr, "application/xml");
// print the name of the root element or error message
console.log(dom.documentElement.nodeName == "parsererror" ? "error while parsing" : dom.documentElement.nodeName);
</pre>
</div>

<h3 id="Parsing_URL-addressable_resources_into_DOM_trees">Parsing URL-addressable resources into DOM trees</h3>

<h4 id="Using_XMLHttpRequest">Using XMLHttpRequest</h4>

<p>Here is sample code that reads and parses a URL-addressable XML file into a DOM tree:</p>

<pre class="brush: js notranslate">const xhr = new XMLHttpRequest();

xhr.onload = function() {
  dump(xhr.responseXML.documentElement.nodeName);
}

xhr.onerror = function() {
  dump("Error while getting XML.");
}

xhr.open("GET", "example.xml");
xhr.responseType = "document";
xhr.send();
</pre>

<p>The value returned in the <code>xhr</code> object's {{domxref("XMLHttpRequest.responseXML", "responseXML")}} field is a {{domxref("Document")}} constructed by parsing the XML.</p>

<p>If the document is {{Glossary("HTML")}}, the code shown above will return a {{domxref("Document")}}. If the document is XML, the resulting object is actually a {{domxref("XMLDocument")}}. The two types are essentially the same; the difference is largely historical, although differentiating has some practical benefits as well.</p>

<div class="note">
<p><strong>Note:</strong> There is in fact an {{domxref("HTMLDocument")}} interface as well, but it is not necessarily an independent type. In some browsers it is, while in others it is an alias for the <code>Document</code> interface.</p>
</div>

<h2 id="Serializing_an_XML_document">Serializing an XML document</h2>

<p>Given a {{domxref("Document")}}, you can serialize the document's DOM tree back into XML using the {{domxref("XMLSerializer.serializeToString()")}} method.</p>

<p>Use the following approaches to serialize the contents of the XML document you created in the previous section.</p>

<h3 id="Serializing_DOM_trees_to_strings">Serializing DOM trees to strings</h3>

<p>First, create a DOM tree as described in <a href="/en/How_to_create_a_DOM_tree" title="en/How_to_create_a_DOM_tree">How to Create a DOM tree</a>. Alternatively, use a DOM tree obtained from {{ domxref("XMLHttpRequest") }}.</p>

<p>To serialize the DOM tree <code>doc</code> into XML text, call {{domxref("XMLSerializer.serializeToString()")}}:</p>

<pre class="brush: js notranslate">const serializer = new XMLSerializer();
const xmlStr = serializer.serializeToString(doc);</pre>

<h3 id="Serializing_HTML_documents">Serializing HTML documents</h3>

<p>If the DOM you have is an HTML document, you can serialize using <code>serializeToString()</code>, but there is a simpler option: just use the {{domxref("Element.innerHTML")}} property (if you want just the descendants of the specified node) or the {{domxref("Element.outerHTML")}} property if you want the node and all its descendants.</p>

<pre class="brush: js notranslate">const docInnerHtml = document.documentElement.innerHTML;
</pre>

<p>As a result, <code>docHTML</code> is a {{domxref("DOMString")}} containing the HTML of the contents of the document; that is, the {{HTMLElement("body")}} element's contents.</p>

<p>You can get HTML corresponding to the <code>&lt;body&gt;</code> <em>and</em> its descendants with this code:</p>

<pre class="brush: js notranslate">const docOuterHtml = document.documentElement.outerHTML;</pre>

<h2 id="See_also">See also</h2>

<ul>
	<li><a class="internal" href="/en/XPath" title="en/XPath">XPath</a></li>
	<li>{{domxref("XMLHttpRequest")}}</li>
	<li>{{domxref("Document")}}, {{domxref("XMLDocument")}}, and {{domxref("HTMLDocument")}}</li>
</ul>
